Subject: Node Requirements: issue 17 - MIPv6

From: Thomas Narten <[email-masked]>
Date: Fri, 24 Jul 2009 11:41:01 -0400

The document currently says:

>    8.  Mobile IP
> 
>    The Mobile IPv6 [RFC3775] specification defines requirements for the
>    following types of nodes:
> 
>       - mobile nodes
>       - correspondent nodes with support for route optimization
>       - home agents
>       - all IPv6 routers
> 
>    Hosts MAY support mobile node functionality described in Section 8.5
>    of [RFC3775], including support of generic packet tunneling [RFC2473]
>    and secure home agent communications [RFC4877].
> 
>    Hosts SHOULD support route optimization requirements for
>    correspondent nodes described in Section 8.2 of [RFC3775].
> 
>    Routers SHOULD support the generic mobility-related requirements for
>    all IPv6 routers described in Section 8.3 of [RFC3775].  Routers MAY
>    support the home agent functionality described in Section 8.4 of
>    [RFC3775], including support of [RFC2473] and [RFC4877].

I think the above text needs updating. As with SEND, I do not believe
we have sufficient implementation and deployment experience to make a
general SHOULD recommendations for RO.

I would like to get a better sense of what the implementation status
of MIPv6 is. AFAIK, it is not implemented in mainstream products (or
distributions) at this time. Moreover, RO is new technology to IPv6
(MIPv4 does not have it), making it even more important to get real
deployment and operational experience before making a broad SHOULD
recommendation.

The first MAY recommendation basically says that implementing mobility
functions (i.e., being a mobile node) is completely optional. That seems
fine.

The second recommendation says that generic hosts SHOULD implement
RO. But, RO primarily benefits mobile nodes, so it is in some sense an
unfunded mandate for hosts. Hosts pay a cost for implementing RO, but
don't see much, if any, benefit. Moreover, it is unclear at this point
that we have any significant deployment experience with this
technology. 

W.r.t. RO, discussion in the past has also raised concerns as to
whether larger content servers (i.e., amazons and googles) would be
willing to support RO. They raised concerns about scalability, etc.

Thus, in the absence of significant deployment and operational
experience, I think it is premature to broadly recommend implemenation
of RO. A MAY for general hosts seems about the best we can do.

Regarding the last recommendation, that Routers SHOULD support generic
mobility-related requirements, this means (from RFC3775):

>    8.3.  All IPv6 Routers
> 
>    All IPv6 routers, even those not serving as a home agent for Mobile
>    IPv6, have an effect on how well mobile nodes can communicate:
> 
>    o  Every IPv6 router SHOULD be able to send an Advertisement Interval
>       option (Section 7.3) in each of its Router Advertisements [12], to
>       aid movement detection by mobile nodes (as in Section 11.5.1).
>       The use of this option in Router Advertisements SHOULD be
>       configurable.
> 
>    o  Every IPv6 router SHOULD be able to support sending unsolicited
>       multicast Router Advertisements at the faster rate described in
>       Section 7.5.  If the router supports a faster rate, the used rate
>       MUST be configurable.
> 
>    o  Each router SHOULD include at least one prefix with the Router
>       Address (R) bit set and with its full IP address in its Router
>       Advertisements (as described in Section 7.2).
> 
>    o  Routers supporting filtering packets with routing headers SHOULD
>       support different rules for type 0 and type 2 routing headers (see
>       Section 6.4) so that filtering of source routed packets (type 0)
>       will not necessarily limit Mobile IPv6 traffic which is delivered
>       via type 2 routing headers.

I think that these recommendations are generally OK. Indeed, I think
it is a bit unfortunate that those recommendations are hidden within
the MIPv6 spec as opposed to being merged in with the ND spec, but
that isn't something node requirments can address.

Comments?

Thomas

---

From: <[email-masked]>
Date: Fri, 24 Jul 2009 20:14:26 +0200

Hi Thomas,

> general SHOULD recommendations for RO.

I agree that Route Optimization is non-existent at the present time. Given
the current state of MIP6 itself, a SHOULD for RO is an exaggeration. If at
all it needs to be mentioned, MAY is sufficient.

> distributions) at this time.

I don't know of any mainstream implementations of MIP6. IMO, MIP6 [RFC3775]
by itself is plagued by the fact that it required native IPv6 networks. And
given the current state of thinking w.r.t transition and co-existence with
IPv4, the applicability of MIP6 is limited.
Dual-stack MIP6 [RFC5555] is however cognizant of the reality and is able to
work across all types of accesses. It is a much more practical protocol for
real-world deployments. Hence my recommendation would be to drop MIP6 from
the node requirements document and instead reference DSMIP6.

> Moreover, RO is new technology to IPv6

Right. The need for RO at this time is non-existent.

> that we have any significant deployment experience with this

Agree. I think RO can be removed from the node-requirements document without
any harm. 

> willing to support RO. They raised concerns about scalability, etc.

Have not seen any requirements for RO being essential at this time.

> of RO. A MAY for general hosts seems about the best we can do.

MAY or even remove it. Either would be fine.

> mobility-related requirements, this means (from RFC3775):

I think we should remove the reference to RFC3775 and instead point to
RFC5555. 

> that isn't something node requirments can address.

Right. Given the lack of MIP6 implementation, these recommendations tend to
get lost. At least by mentioning it in the node-requirements document, these
recommendations have a chance of being implemented.

-Raj

> 
> Comments?
> 
> Thomas
> --------------------------------------------------------------------
> IETF IPv6 working group mailing list
> [email-masked]
> Administrative Requests: https://www.ietf.org/mailman/listinfo/ipv6
> --------------------------------------------------------------------

---

From: Alexandru Petrescu <[email-masked]>
Date: Fri, 24 Jul 2009 20:57:48 +0200

I tend to think MIPv6 RO is not deployed in CNs, at least not as wide as
expected.

With respect to Raj's earlier suggestion, I wouldn't agree substituting
RFC5555 for RFC3775, i.e. to use DSMIPv6 instead of Mobile IPv6 -
because Mobile IPv6 and Mobile IPv4 have been used successfully for this
goal, with practical implementations, simultaneously; whereas I'm not
aware of DSMIPv6 implementations(?).

I would also recommend to suggest the use of NEMOv6 protocol extensions
to Mobile IPv6, whenever talking Mobile Nodes.  I.e. say "Mobile Nodes
(Mobile Hosts and Mobile Routers RFC3963)".  It would have been easier
if RFC3775 referred to RFC3963 but it's not the case, and 3775bis not too.

RFC3963 NEMOv6 implementations are probably as widespread as Mobile IPv6
implementations.  Additionally, radvd (which is widely used on linux)
does mention RFC3963 and does implement the HA NEMOv6 features necessary
in RA.

I think the qualification of use of NEMOv6 RFC3963 could be as strong as
RFC3775 (MAY?).

For example, for this current Node Requirements text:
> all IPv6 routers described in Section 8.3 of [RFC-3775].  Routers MAY
> [RFC-3775], including support of [RFC-2473] and [RFC-3776].

I'd suggest  something like: "Routers (Mobile Routers or Home Agents)
MAY support Mobile Router and Home Agents respective implementations, as
described in RFC3775 and RFC3963."  Or similar.

A Mobile Router is different from a Router, for example, because of a 
relatively strong recommendation, in that it must not join (capitalized) 
the all-routers link-local multicast address when not at home.

Finally, RFC3776 has been updated by another RFC, which could be
mentioned.  Whose implementation status I don't know.

Just some thoughts,

Alex

Thomas Narten a écrit :
>> The Mobile IPv6 [RFC3775] specification defines requirements for
>> the following types of nodes:
>> 
>> - mobile nodes - correspondent nodes with support for route
>> optimization - home agents - all IPv6 routers
>> 
>> Hosts MAY support mobile node functionality described in Section
>> 8.5 of [RFC3775], including support of generic packet tunneling
>> [RFC2473] and secure home agent communications [RFC4877].
>> 
>> Routers SHOULD support the generic mobility-related requirements
>> for all IPv6 routers described in Section 8.3 of [RFC3775].
>> Routers MAY support the home agent functionality described in
>> Section 8.4 of [RFC3775], including support of [RFC2473] and
>> [RFC4877].
> 
> 
>  we have sufficient implementation and deployment experience to make
> a general SHOULD recommendations for RO.
> 
> The first MAY recommendation basically says that implementing
> mobility functions (i.e., being a mobile node) is completely
> optional. That seems fine.
> 
> RO. But, RO primarily benefits mobile nodes, so it is in some sense
> an unfunded mandate for hosts. Hosts pay a cost for implementing RO,
> but don't see much, if any, benefit. Moreover, it is unclear at this
> point that we have any significant deployment experience with this 
> technology.
> 
> experience, I think it is premature to broadly recommend
> implemenation of RO. A MAY for general hosts seems about the best we
> can do.
> 
> Regarding the last recommendation, that Routers SHOULD support
> generic mobility-related requirements, this means (from RFC3775):
> 
>> 8.3.  All IPv6 Routers
>> 
>> o  Every IPv6 router SHOULD be able to send an Advertisement
>> Interval option (Section 7.3) in each of its Router Advertisements
>> [12], to aid movement detection by mobile nodes (as in Section
>> 11.5.1). The use of this option in Router Advertisements SHOULD be 
>> configurable.
>> 
> IETF IPv6 working group mailing list [email-masked] Administrative
> Requests: https://www.ietf.org/mailman/listinfo/ipv6

---

From: <[email-masked]>
Date: Sat, 25 Jul 2009 07:57:08 +0200

Thomas,

I agree with this approach.  The thought was that RO would be a good thing if you considered that MIPv6 would be deployed, so that most IPv6 nodes should support it.  However, the deployability of MIPv6 look quite tough right now, and the as we will live with a mixed v4-v6 world, RO won't get us far.

John

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of ext Thomas Narten
Sent: Friday, July 24, 2009 11:41 AM
To: [email-masked]
Subject: Node Requirements: issue 17 - MIPv6

>    [RFC3775], including support of [RFC2473] and [RFC4877].

I think the above text needs updating. As with SEND, I do not believe we have sufficient implementation and deployment experience to make a general SHOULD recommendations for RO.

I would like to get a better sense of what the implementation status of MIPv6 is. AFAIK, it is not implemented in mainstream products (or
distributions) at this time. Moreover, RO is new technology to IPv6
(MIPv4 does not have it), making it even more important to get real deployment and operational experience before making a broad SHOULD recommendation.

The first MAY recommendation basically says that implementing mobility functions (i.e., being a mobile node) is completely optional. That seems fine.

The second recommendation says that generic hosts SHOULD implement RO. But, RO primarily benefits mobile nodes, so it is in some sense an unfunded mandate for hosts. Hosts pay a cost for implementing RO, but don't see much, if any, benefit. Moreover, it is unclear at this point that we have any significant deployment experience with this technology. 

W.r.t. RO, discussion in the past has also raised concerns as to whether larger content servers (i.e., amazons and googles) would be willing to support RO. They raised concerns about scalability, etc.

Thus, in the absence of significant deployment and operational experience, I think it is premature to broadly recommend implemenation of RO. A MAY for general hosts seems about the best we can do.

>       via type 2 routing headers.

I think that these recommendations are generally OK. Indeed, I think it is a bit unfortunate that those recommendations are hidden within the MIPv6 spec as opposed to being merged in with the ND spec, but that isn't something node requirments can address.

Comments?

Thomas

---

From: [email-masked] (Arnaud Ebalard)
Date: Fri, 24 Jul 2009 21:26:33 +0200

Hi,

> aware of DSMIPv6 implementations(?).

I am also against switching from RFC 3775 to RFC 5555. I think *far
more* feedback on DSMIPv6 is needed, i.e. implementation and deployment.   

> I think the qualification of use of NEMOv6 RFC3963 could be as strong as

+1. If one ask someone the reference documents about MIPv6, the answer
will probably be RFC 3775, RFC 3963 and RFC 4877. From a development
standpoint, extending an existing MIPv6 implementation to support NEMO
is easy. IMHO, it is a good idea to have NEMO at the same level as
MIPv6. 

> relatively strong recommendation, in that it must not join
> (capitalized) the all-routers link-local multicast address when not at
> home.
>

RFC 4877.

Cheers,

a+

---

From: Alexandru Petrescu <[email-masked]>
Date: Wed, 29 Jul 2009 10:44:38 +0200

Thomas,

After reading the forthcoming 6MAN slides, about MIPv6 in Node
Requirements, let me draw attention on the NEMOv6 RFC3963, absent from 
the slides.

I believe NEMOv6 RFC3963 should be mentioned too, because it is an
extension to RFC3775 and has been implemented.  RFC3775 doesn't cite
NEMOv6, neither does RFC3775bis.

What do you think?

Alex